package nc.bs.scaba.actualcostcal.cal;

package ..deTemp.1739154623306;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import nc.bd.framework.base.CMArrayUtil;
import nc.bd.framework.base.CMCollectionUtil;
import nc.bd.framework.base.CMStringUtil;
import nc.bd.framework.db.CMSqlBuilder;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.scaba.actualcostcal.cal.StuffQueryProcessor;
import nc.bs.scaba.actualcostcal.entity.ActualContext;
import nc.bs.scaba.actualcostcal.util.ActualcostCommonUtil;
import nc.bs.scaba.actualcostcal.util.Converter;
import nc.impl.pubapp.pattern.database.DataAccessUtils;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pub.scaba.sql.ScabaSqlBuilder;
import nc.vo.ia.detailledger.para.scaba.AuditPara;
import nc.vo.ia.detailledger.para.scaba.CailiaoCostParamVO;
import nc.vo.ia.detailledger.para.scaba.CailiaoCostVO;
import nc.vo.ia.detailledger.para.scaba.InventoryParamVO;
import nc.vo.ia.detailledger.para.scaba.RewriteRangePara;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.data.IRowSet;
import nc.vo.pubapp.pattern.model.entity.bill.AbstractBill;
import nc.vo.scaba.costprocess.entity.MonthabVO;
import nc.vo.scaba.iastuff.entity.IastuffAggVO;
import nc.vo.scaba.iastuff.entity.IastuffHeadVO;
import nc.vo.scaba.iastuff.entity.IastuffItemVO;
import nc.vo.scaba.inprocost.entity.InproCostAggVO;
import nc.vo.scaba.inprocost.entity.InproCostHeadVO;
import nc.vo.scaba.inprocost.entity.InproCostItemVO;
import nc.vo.scaba.stuff.entity.StuffAggVO;
import nc.vo.scaba.stuff.entity.StuffHeadVO;
import nc.vo.scaba.stuff.entity.StuffItemVO;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.ArrayUtils;

public class IAParamProcesser {
  ActualContext context;
  
  private Set<String> unionMaterial = new HashSet<>();
  
  Map<String, List<String>> unionMaterMap = new HashMap<>();
  
  private final String MATERIAL_FIELD = "cmaterialid";
  
  private final String MAIN_FIELD = "cmainmaterialid";
  
  Map<String, Integer> lowerUAMap = null;
  
  public IAParamProcesser(ActualContext context) {
    this.context = context;
  }
  
  public void execute(ActualContext context) {}
  
  private void getUnionMaterial(Set<String> bodyMaterials) throws DAOException {
    if (CMCollectionUtil.isEmpty(bodyMaterials))
      return; 
    BaseDAO baseDAO = new BaseDAO();
    ScabaSqlBuilder sql = new ScabaSqlBuilder();
    sql.append("select distinct co.cmaterialid cmaterialid, cmain.cmaterialid cmainmaterialid from mapub_costobject co  ");
    sql.append("inner join mapub_costobject cmain on co.cmaincostobjectid = cmain.ccostobjectid where co.cmaterialid", bodyMaterials);
    sql.append(" and co.fproducttype =2 ");
    List<Map<String, String>> materials = (List<Map<String, String>>)baseDAO.executeQuery(sql.toString(), (ResultSetProcessor)new MapListProcessor());
    materials.stream().forEach(item -> {
          String key = item.get("cmaterialid");
          String val = item.get("cmainmaterialid");
          if (CMCollectionUtil.isEmpty(this.unionMaterMap.get(key))) {
            List<String> mainmaterials = new ArrayList<>();
            mainmaterials.add(val);
            this.unionMaterMap.put(key, mainmaterials);
          } else {
            ((List<String>)this.unionMaterMap.get(key)).add(val);
          } 
        });
    this.unionMaterial.addAll(this.unionMaterMap.keySet());
    this.context.getAllUnioinMaterial().addAll(this.unionMaterial);
  }
  
  public AuditPara getAuditPara(StuffAggVO[] stuffs, IastuffAggVO[] otherStuffs) throws BusinessException {
    ActualContext context = this.context;
    String direction = context.getDirection();
    String pk_book = context.getAccountBook();
    String caccountperiod = context.getPeriod();
    AuditPara auditPara = new AuditPara();
    auditPara.setPk_book(pk_book);
    auditPara.setCaccountperiod(caccountperiod);
    Set<String> costRegins = context.getCostRegins();
    ArrayList<StuffItemVO> cycleItems = new ArrayList<>();
    ArrayList<StuffItemVO> uncycleItems = new ArrayList<>();
    ArrayList<IastuffItemVO> otherCycleItems = new ArrayList<>();
    ArrayList<IastuffItemVO> otherUncycleItems = new ArrayList<>();
    StuffQueryProcessor stuffProcess = new StuffQueryProcessor(context);
    InproCostAggVO[] inprocostAggs = null;
    List<MonthabVO> onprodVos = null;
    if (context.getIsBeginPeriod().booleanValue()) {
      inprocostAggs = stuffProcess.getInprocost();
    } else {
      onprodVos = stuffProcess.getOnprodVos();
    } 
    if (ArrayUtils.isEmpty((Object[])stuffs) && ArrayUtils.isEmpty((Object[])otherStuffs) && ArrayUtils.isEmpty((Object[])inprocostAggs) && CMCollectionUtil.isEmpty(onprodVos))
      return null; 
    if (context.getCurrentLevel().intValue() == 1 || context.getCurrentLevel().intValue() == 0) {
      Set<InventoryParamVO> lastInventoryParamVOs = new HashSet<>();
      if (CMArrayUtil.isNotEmpty((Object[])inprocostAggs)) {
        InproCostAggVO[] arrayOfInproCostAggVO;
        int j = (arrayOfInproCostAggVO = inprocostAggs).length;
        for (byte b = 0; b < j; b++) {
          InproCostAggVO agg = arrayOfInproCostAggVO[b];
          InproCostHeadVO head = agg.getParentVO();
          InventoryParamVO paramVO = Converter.inprocostHeadToInventoryParamVO(head);
          lastInventoryParamVOs.add(paramVO);
        } 
      } 
      if (CMCollectionUtil.isNotEmpty(onprodVos))
        for (MonthabVO month : onprodVos) {
          InventoryParamVO paramVO = Converter.monthabToInventoryParamVO(month);
          lastInventoryParamVOs.add(paramVO);
        }  
      int i;
      for (i = 0; i < stuffs.length; i++) {
        StuffAggVO aggVO = stuffs[i];
        StuffHeadVO headVo = aggVO.getParentVO();
        InventoryParamVO paramVO = Converter.stuffHeadToInventoryParamVO(headVo);
        lastInventoryParamVOs.add(paramVO);
      } 
      for (i = 0; i < otherStuffs.length; i++) {
        IastuffAggVO aggVO = otherStuffs[i];
        IastuffHeadVO headVo = aggVO.getParentVO();
        InventoryParamVO paramVO = Converter.stuffHeadToInventoryParamVO(headVo);
        lastInventoryParamVOs.add(paramVO);
      } 
      context.setLastParamVOs(lastInventoryParamVOs);
    } 
    Set<String> cdetailledgerids = new HashSet<>();
    HashSet<String> headMaterials = new HashSet<>();
    Set<String> bodyMaterials = new HashSet<>();
    Arrays.<StuffAggVO>stream(stuffs).forEach(stuff -> {
          StuffHeadVO header = stuff.getParentVO();
          StuffItemVO[] itemVos = stuff.getItemVO();
          StuffItemVO[] arrayOfStuffItemVO1;
          int i = (arrayOfStuffItemVO1 = itemVos).length;
          for (byte b = 0; b < i; b++) {
            StuffItemVO item = arrayOfStuffItemVO1[b];
            paramSet1.add(item.getCdetailledgerid());
            if (CMStringUtil.isNotEmpty(item.getCmaterialid()))
              paramSet2.add(item.getCmaterialid()); 
          } 
          paramHashSet.add(header.getCmaterialid());
        });
    Arrays.<IastuffAggVO>stream(otherStuffs).forEach(stuff -> {
          IastuffHeadVO header = stuff.getParentVO();
          paramHashSet.add(header.getCmaterialid());
          IastuffItemVO[] itemVos = stuff.getItemVO();
          IastuffItemVO[] arrayOfIastuffItemVO1;
          int i = (arrayOfIastuffItemVO1 = itemVos).length;
          for (byte b = 0; b < i; b++) {
            IastuffItemVO item = arrayOfIastuffItemVO1[b];
            if (CMStringUtil.isNotEmpty(item.getCmaterialid()))
              paramSet.add(item.getCmaterialid()); 
          } 
        });
    getUnionMaterial(bodyMaterials);
    HashMap<StuffItemVO, StuffHeadVO> stuffMap = dealItem(context, cycleItems, uncycleItems, StuffHeadVO.class, StuffItemVO.class, headMaterials, stuffs);
    HashMap<IastuffItemVO, IastuffHeadVO> otherStuffMap = dealItem(context, otherCycleItems, otherUncycleItems, IastuffHeadVO.class, IastuffItemVO.class, headMaterials, otherStuffs);
    Set<InventoryParamVO> param = new HashSet<>();
    for (StuffItemVO item : uncycleItems) {
      StuffHeadVO head = stuffMap.get(item);
      if (ActualcostCommonUtil.checkISourceType(head.getIsourcetype()).booleanValue() || item.getNmoney() == null) {
        InventoryParamVO parmVO = itemConvert(item);
        param.add(parmVO);
      } 
    } 
    if (!MapUtils.isEmpty(otherStuffMap))
      otherUncycleItems.forEach(item -> {
            InventoryParamVO parmVO = otherItemConvert(item);
            paramSet.add(parmVO);
          }); 
    if (CMArrayUtil.isNotEmpty((Object[])inprocostAggs)) {
      InproCostAggVO[] arrayOfInproCostAggVO;
      int i = (arrayOfInproCostAggVO = inprocostAggs).length;
      for (byte b = 0; b < i; b++) {
        InproCostAggVO agg = arrayOfInproCostAggVO[b];
        InproCostItemVO[] items = agg.getItemVO();
        if (CMArrayUtil.isNotEmpty((Object[])items)) {
          InproCostItemVO[] arrayOfInproCostItemVO;
          int j = (arrayOfInproCostItemVO = items).length;
          for (byte b1 = 0; b1 < j; b1++) {
            InproCostItemVO item = arrayOfInproCostItemVO[b1];
            if ((!direction.equals("2") || headMaterials.contains(item.getCmaterialid())) && item.getCmaterialid() != null) {
              InventoryParamVO paramVO = inprocostItemConvert(item);
              param.add(paramVO);
            } 
          } 
        } 
      } 
    } 
    auditPara.setPk_orgs(costRegins);
    auditPara.setParams(param);
    ArrayList<CailiaoCostParamVO> rewriteParams = new ArrayList<>();
    Map<String, List<StuffItemVO>> cycleItemMap = (Map<String, List<StuffItemVO>>)cycleItems.stream().collect(Collectors.groupingBy(StuffItemVO::getPk_org));
    HashSet<InventoryParamVO> i6InventoryParamVOs = new HashSet<>();
    cycleItemMap.forEach((key, items) -> {
          CailiaoCostParamVO cailiaoParam = new CailiaoCostParamVO();
          RewriteRangePara range = new RewriteRangePara();
          range.setCstockorgid(key);
          range.setCaccountperiod(paramString1);
          range.setCbilltype("I6");
          range.setPk_book(paramString2);
          range.setCdetailledgerids(paramSet1);
          List<CailiaoCostVO> costVos = new ArrayList<>();
          for (int i = 0; i < items.size(); i++) {
            StuffItemVO vo = items.get(i);
            CailiaoCostVO costVo = new CailiaoCostVO();
            StuffHeadVO headVo = (StuffHeadVO)paramHashMap.get(vo);
            costVo.setPk_org(vo.getCsrccostdomainid());
            costVo.setCcostobjid(headVo.getCmaterialid());
            costVo.setCcostclassid(headVo.getCfipmarcostclassid());
            costVo.setBreworkflag(ActualcostCommonUtil.isRework(headVo.getFinstoragetype()));
            costVo.setBwwflag(ActualcostCommonUtil.isWW(headVo.getFinstoragetype()));
            costVo.setCcostasscustid(headVo.getCcustomerid());
            costVo.setCcostvendorid(headVo.getCvendorid());
            costVo.setCproductorid(headVo.getCproductorid());
            costVo.setCprojectid(headVo.getCprojectid());
            costVo.setVcostfree1(headVo.getVfree1());
            costVo.setVcostfree2(headVo.getVfree2());
            costVo.setVcostfree3(headVo.getVfree3());
            costVo.setVcostfree4(headVo.getVfree4());
            costVo.setVcostfree5(headVo.getVfree5());
            costVo.setVcostfree6(headVo.getVfree6());
            costVo.setVcostfree7(headVo.getVfree7());
            costVo.setVcostfree8(headVo.getVfree8());
            costVo.setVcostfree9(headVo.getVfree9());
            costVo.setVcostfree10(headVo.getVfree10());
            costVo.setCinventoryid(vo.getCmaterialid());
            costVo.setCasscustid(vo.getCcustomerid());
            costVo.setCvendorid(vo.getCvendorid());
            costVo.setCproductorid(vo.getCproductorid());
            costVo.setCproductorid(vo.getCproductorid());
            costVo.setVfree1(vo.getVbfree1());
            costVo.setVfree2(vo.getVbfree2());
            costVo.setVfree3(vo.getVbfree3());
            costVo.setVfree4(vo.getVbfree4());
            costVo.setVfree5(vo.getVbfree5());
            costVo.setVfree6(vo.getVbfree6());
            costVo.setVfree7(vo.getVbfree7());
            costVo.setVfree8(vo.getVbfree8());
            costVo.setVfree9(vo.getVbfree9());
            costVo.setVfree10(vo.getVbfree10());
            costVo.setCcostcenterid(headVo.getCcostcenterid());
            costVos.add(costVo);
            InventoryParamVO inventoryParamVO = itemConvert(vo);
            paramHashSet.add(inventoryParamVO);
          } 
          paramActualContext.setI6InventoryParamVOs(paramHashSet);
          range.setPk_orgs((String[])paramSet2.toArray((Object[])new String[0]));
          cailiaoParam.setRange(range);
          cailiaoParam.setCostVOs(costVos.<CailiaoCostVO>toArray(new CailiaoCostVO[0]));
          paramArrayList.add(cailiaoParam);
        });
    HashSet<String> otherBillId = new HashSet<>();
    HashSet<InventoryParamVO> i7InventoryParamVOs = new HashSet<>();
    otherCycleItems.forEach(item -> {
          paramHashSet1.add(item.getCsourcebillid());
          InventoryParamVO inventoryParamVO = otherItemConvert(item);
          paramHashSet2.add(inventoryParamVO);
        });
    context.setI6Param(rewriteParams.<CailiaoCostParamVO>toArray(new CailiaoCostParamVO[0]));
    context.setI7Param(otherBillId.<String>toArray(new String[0]));
    context.setI7InventoryParamVOs(i7InventoryParamVOs);
    return auditPara;
  }
  
  private InventoryParamVO itemConvert(StuffItemVO item) {
    InventoryParamVO parmVO = new InventoryParamVO();
    parmVO.setCinventoryid(item.getCmaterialid());
    parmVO.setCasscustid(item.getCcustomerid());
    parmVO.setCproductorid(item.getCproductorid());
    parmVO.setCprojectid(item.getCprojectid());
    parmVO.setCvendorid(item.getCvendorid());
    parmVO.setVfree1(item.getVbfree1());
    parmVO.setVfree2(item.getVbfree2());
    parmVO.setVfree3(item.getVbfree3());
    parmVO.setVfree4(item.getVbfree4());
    parmVO.setVfree5(item.getVbfree5());
    parmVO.setVfree6(item.getVbfree6());
    parmVO.setVfree7(item.getVbfree7());
    parmVO.setVfree8(item.getVbfree8());
    parmVO.setVfree9(item.getVbfree9());
    parmVO.setVfree10(item.getVbfree10());
    return parmVO;
  }
  
  private InventoryParamVO otherItemConvert(IastuffItemVO item) {
    InventoryParamVO parmVO = new InventoryParamVO();
    parmVO.setCinventoryid(item.getCmaterialid());
    parmVO.setCasscustid(item.getCcustomerid());
    parmVO.setCproductorid(item.getCproductorid());
    parmVO.setCprojectid(item.getCprojectid());
    parmVO.setCvendorid(item.getCvendorid());
    parmVO.setVfree1(item.getVbfree1());
    parmVO.setVfree2(item.getVbfree2());
    parmVO.setVfree3(item.getVbfree3());
    parmVO.setVfree4(item.getVbfree4());
    parmVO.setVfree5(item.getVbfree5());
    parmVO.setVfree6(item.getVbfree6());
    parmVO.setVfree7(item.getVbfree7());
    parmVO.setVfree8(item.getVbfree8());
    parmVO.setVfree9(item.getVbfree9());
    parmVO.setVfree10(item.getVbfree10());
    return parmVO;
  }
  
  private InventoryParamVO inprocostItemConvert(InproCostItemVO item) {
    InventoryParamVO parmVO = new InventoryParamVO();
    parmVO.setCinventoryid(item.getCmaterialid());
    parmVO.setCasscustid(item.getCcustomerid());
    parmVO.setCproductorid(item.getCproductorid());
    parmVO.setCprojectid(item.getCprojectid());
    parmVO.setCvendorid(item.getCvendorid());
    parmVO.setVfree1(item.getVbfree1());
    parmVO.setVfree2(item.getVbfree2());
    parmVO.setVfree3(item.getVbfree3());
    parmVO.setVfree4(item.getVbfree4());
    parmVO.setVfree5(item.getVbfree5());
    parmVO.setVfree6(item.getVbfree6());
    parmVO.setVfree7(item.getVbfree7());
    parmVO.setVfree8(item.getVbfree8());
    parmVO.setVfree9(item.getVbfree9());
    parmVO.setVfree10(item.getVbfree10());
    return parmVO;
  }
  
  private <H extends nc.vo.pub.ISuperVO, I extends nc.vo.pub.ISuperVO, A extends AbstractBill> HashMap<I, H> dealItem(ActualContext context, List<I> cycle, List<I> uncycle, Class<H> headClass, Class<I> itemClass, HashSet<String> headMaterials, AbstractBill... stuffs) {
    // Byte code:
    //   0: new java/util/HashMap
    //   3: dup
    //   4: invokespecial <init> : ()V
    //   7: astore #8
    //   9: aload #7
    //   11: ifnull -> 20
    //   14: aload #7
    //   16: arraylength
    //   17: ifne -> 22
    //   20: aconst_null
    //   21: areturn
    //   22: iconst_0
    //   23: istore #9
    //   25: goto -> 205
    //   28: aload #7
    //   30: iload #9
    //   32: aaload
    //   33: astore #10
    //   35: aload #10
    //   37: invokevirtual getParent : ()Lnc/vo/pub/ISuperVO;
    //   40: astore #11
    //   42: aload #10
    //   44: invokevirtual getChildrenVO : ()[Lnc/vo/pub/CircularlyAccessibleValueObject;
    //   47: checkcast [Lnc/vo/pub/ISuperVO;
    //   50: astore #12
    //   52: iconst_0
    //   53: istore #13
    //   55: goto -> 194
    //   58: aload #12
    //   60: iload #13
    //   62: aaload
    //   63: ldc 'cmaterialid'
    //   65: invokestatic getProperty : (Ljava/lang/Object;Ljava/lang/String;)Ljava/lang/Object;
    //   68: checkcast java/lang/String
    //   71: astore #14
    //   73: aload #6
    //   75: aload #14
    //   77: invokevirtual contains : (Ljava/lang/Object;)Z
    //   80: ifne -> 116
    //   83: aload_0
    //   84: getfield context : Lnc/bs/scaba/actualcostcal/entity/ActualContext;
    //   87: invokevirtual getDirection : ()Ljava/lang/String;
    //   90: ldc_w '2'
    //   93: invokevirtual equals : (Ljava/lang/Object;)Z
    //   96: ifeq -> 116
    //   99: aload_0
    //   100: getfield unionMaterial : Ljava/util/Set;
    //   103: aload #14
    //   105: invokeinterface contains : (Ljava/lang/Object;)Z
    //   110: ifne -> 178
    //   113: goto -> 191
    //   116: aload_0
    //   117: getfield context : Lnc/bs/scaba/actualcostcal/entity/ActualContext;
    //   120: invokevirtual getDirection : ()Ljava/lang/String;
    //   123: ldc_w '1'
    //   126: invokevirtual equals : (Ljava/lang/Object;)Z
    //   129: ifeq -> 178
    //   132: aload_0
    //   133: getfield unionMaterial : Ljava/util/Set;
    //   136: aload #14
    //   138: invokeinterface contains : (Ljava/lang/Object;)Z
    //   143: ifeq -> 178
    //   146: aload_0
    //   147: getfield context : Lnc/bs/scaba/actualcostcal/entity/ActualContext;
    //   150: invokevirtual getAllLevelMaterialSet : ()Ljava/util/Set;
    //   153: aload_0
    //   154: getfield unionMaterMap : Ljava/util/Map;
    //   157: aload #14
    //   159: invokeinterface get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   164: checkcast java/util/Collection
    //   167: invokeinterface containsAll : (Ljava/util/Collection;)Z
    //   172: ifeq -> 178
    //   175: goto -> 191
    //   178: aload #8
    //   180: aload #12
    //   182: iload #13
    //   184: aaload
    //   185: aload #11
    //   187: invokevirtual put : (Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;
    //   190: pop
    //   191: iinc #13, 1
    //   194: iload #13
    //   196: aload #12
    //   198: arraylength
    //   199: if_icmplt -> 58
    //   202: iinc #9, 1
    //   205: iload #9
    //   207: aload #7
    //   209: arraylength
    //   210: if_icmplt -> 28
    //   213: aload_1
    //   214: invokevirtual getCurrentLevel : ()Ljava/lang/Integer;
    //   217: astore #9
    //   219: new java/util/ArrayList
    //   222: dup
    //   223: invokespecial <init> : ()V
    //   226: astore #10
    //   228: new java/util/ArrayList
    //   231: dup
    //   232: invokespecial <init> : ()V
    //   235: astore #11
    //   237: aload_0
    //   238: getfield context : Lnc/bs/scaba/actualcostcal/entity/ActualContext;
    //   241: invokevirtual getDirection : ()Ljava/lang/String;
    //   244: ldc_w '2'
    //   247: invokevirtual equals : (Ljava/lang/Object;)Z
    //   250: istore #12
    //   252: aload #8
    //   254: invokevirtual keySet : ()Ljava/util/Set;
    //   257: astore #13
    //   259: aload #13
    //   261: invokeinterface iterator : ()Ljava/util/Iterator;
    //   266: astore #15
    //   268: goto -> 387
    //   271: aload #15
    //   273: invokeinterface next : ()Ljava/lang/Object;
    //   278: checkcast nc/vo/pub/ISuperVO
    //   281: astore #14
    //   283: aload #14
    //   285: ldc 'cmaterialid'
    //   287: invokestatic getProperty : (Ljava/lang/Object;Ljava/lang/String;)Ljava/lang/Object;
    //   290: checkcast java/lang/String
    //   293: astore #16
    //   295: aload #16
    //   297: ifnonnull -> 303
    //   300: goto -> 387
    //   303: aload_0
    //   304: aload #16
    //   306: aload_1
    //   307: invokevirtual getHalfProd : (Ljava/lang/String;Lnc/bs/scaba/actualcostcal/entity/ActualContext;)Ljava/lang/Integer;
    //   310: astore #17
    //   312: iload #12
    //   314: ifeq -> 350
    //   317: aload #8
    //   319: aload #14
    //   321: invokevirtual get : (Ljava/lang/Object;)Ljava/lang/Object;
    //   324: checkcast nc/vo/pub/ISuperVO
    //   327: astore #18
    //   329: aload #18
    //   331: ldc 'cmaterialid'
    //   333: invokestatic getProperty : (Ljava/lang/Object;Ljava/lang/String;)Ljava/lang/Object;
    //   336: checkcast java/lang/String
    //   339: astore #19
    //   341: aload_0
    //   342: aload #19
    //   344: aload_1
    //   345: invokevirtual getHalfProd : (Ljava/lang/String;Lnc/bs/scaba/actualcostcal/entity/ActualContext;)Ljava/lang/Integer;
    //   348: astore #9
    //   350: aload #17
    //   352: ifnull -> 379
    //   355: aload #17
    //   357: invokevirtual intValue : ()I
    //   360: aload #9
    //   362: invokevirtual intValue : ()I
    //   365: if_icmpgt -> 379
    //   368: aload #10
    //   370: aload #14
    //   372: invokevirtual add : (Ljava/lang/Object;)Z
    //   375: pop
    //   376: goto -> 387
    //   379: aload #11
    //   381: aload #14
    //   383: invokevirtual add : (Ljava/lang/Object;)Z
    //   386: pop
    //   387: aload #15
    //   389: invokeinterface hasNext : ()Z
    //   394: ifne -> 271
    //   397: aload_2
    //   398: aload #10
    //   400: invokeinterface addAll : (Ljava/util/Collection;)Z
    //   405: pop
    //   406: aload_3
    //   407: aload #11
    //   409: invokeinterface addAll : (Ljava/util/Collection;)Z
    //   414: pop
    //   415: goto -> 425
    //   418: astore #9
    //   420: aload #9
    //   422: invokestatic wrappException : (Ljava/lang/Exception;)V
    //   425: aload #8
    //   427: areturn
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	428	0	this	Lnc/bs/scaba/actualcostcal/cal/IAParamProcesser;
    //   0	428	1	context	Lnc/bs/scaba/actualcostcal/entity/ActualContext;
    //   0	428	2	cycle	Ljava/util/List;
    //   0	428	3	uncycle	Ljava/util/List;
    //   0	428	4	headClass	Ljava/lang/Class;
    //   0	428	5	itemClass	Ljava/lang/Class;
    //   0	428	6	headMaterials	Ljava/util/HashSet;
    //   0	428	7	stuffs	[Lnc/vo/pubapp/pattern/model/entity/bill/AbstractBill;
    //   9	419	8	stuffMap	Ljava/util/HashMap;
    //   25	188	9	m	I
    //   35	167	10	item	Lnc/vo/pubapp/pattern/model/entity/bill/AbstractBill;
    //   42	160	11	header	Lnc/vo/pub/ISuperVO;
    //   52	150	12	items	[Lnc/vo/pub/ISuperVO;
    //   55	147	13	i	I
    //   73	118	14	bodyMaterial	Ljava/lang/String;
    //   219	196	9	level	Ljava/lang/Integer;
    //   228	187	10	cycleInputs	Ljava/util/ArrayList;
    //   237	178	11	uncycleInputs	Ljava/util/ArrayList;
    //   252	163	12	cancel	Z
    //   259	156	13	items	Ljava/util/Set;
    //   283	104	14	item	Lnc/vo/pub/ISuperVO;
    //   295	92	16	materialId	Ljava/lang/String;
    //   312	75	17	semiFinishedLevel	Ljava/lang/Integer;
    //   329	21	18	header	Lnc/vo/pub/ISuperVO;
    //   341	9	19	materialIdHead	Ljava/lang/String;
    //   420	5	9	e	Ljava/lang/Exception;
    // Local variable type table:
    //   start	length	slot	name	signature
    //   0	428	2	cycle	Ljava/util/List<TI;>;
    //   0	428	3	uncycle	Ljava/util/List<TI;>;
    //   0	428	4	headClass	Ljava/lang/Class<TH;>;
    //   0	428	5	itemClass	Ljava/lang/Class<TI;>;
    //   0	428	6	headMaterials	Ljava/util/HashSet<Ljava/lang/String;>;
    //   9	419	8	stuffMap	Ljava/util/HashMap<TI;TH;>;
    //   35	167	10	item	TA;
    //   42	160	11	header	TH;
    //   228	187	10	cycleInputs	Ljava/util/ArrayList<TI;>;
    //   237	178	11	uncycleInputs	Ljava/util/ArrayList<TI;>;
    //   259	156	13	items	Ljava/util/Set<TI;>;
    //   283	104	14	item	TI;
    //   329	21	18	header	TH;
    // Exception table:
    //   from	to	target	type
    //   9	20	418	java/lang/Exception
    //   22	415	418	java/lang/Exception
  }
  
  public static String getAssInfoItemSql(String tablePrefix) {
    CMSqlBuilder sql = new CMSqlBuilder();
    sql.append(String.valueOf(tablePrefix) + "." + "ccustomerid");
    sql.append("," + tablePrefix + "." + "cvendorid");
    sql.append("," + tablePrefix + "." + "cprojectid");
    sql.append("," + tablePrefix + "." + "cproductorid");
    sql.append("," + tablePrefix + "." + "vbfree1");
    sql.append("," + tablePrefix + "." + "vbfree2");
    sql.append("," + tablePrefix + "." + "vbfree3");
    sql.append("," + tablePrefix + "." + "vbfree4");
    sql.append("," + tablePrefix + "." + "vbfree5");
    sql.append("," + tablePrefix + "." + "vbfree6");
    sql.append("," + tablePrefix + "." + "vbfree7");
    sql.append("," + tablePrefix + "." + "vbfree8");
    sql.append("," + tablePrefix + "." + "vbfree9");
    sql.append("," + tablePrefix + "." + "vbfree10");
    return sql.toString();
  }
  
  protected Integer getHalfProd(String cmaterialid, ActualContext context) {
    Map<String, Integer> keyMap = context.getKeyMap();
    Integer halfProdLevel = keyMap.get(cmaterialid);
    if (halfProdLevel != null)
      return halfProdLevel; 
    if (this.lowerUAMap == null)
      this.lowerUAMap = getLowerUAMap(context); 
    return this.lowerUAMap.get(cmaterialid);
  }
  
  public Map<String, Integer> getLowerUAMap(ActualContext context) {
    HashMap<String, Integer> lowerUAMap = new HashMap<>();
    String[] pk_orgs = context.getFactorys();
    String cperiod = context.getPeriod();
    String pk_group = context.getGroup();
    CMSqlBuilder sql = new CMSqlBuilder();
    sql.append(" select ");
    sql.append("    co.cmaterialid,");
    sql.append("    tranlevel.nlevel");
    sql.append(" from ");
    sql.append("    mapub_costobject maincostobj,scaba_cmlevelcal tranlevel,mapub_costobject co ");
    sql.append(" where ");
    sql.append("    maincostobj.cmaterialid=tranlevel.cmaterialid ");
    sql.append("    and maincostobj.ccostobjectid=co.cmaincostobjectid");
    sql.append("    and maincostobj.pk_group", pk_group);
    sql.append("    and maincostobj.pk_org=tranlevel.pk_org ");
    sql.append("    and maincostobj.dr=0");
    sql.append("    and tranlevel.pk_group", pk_group);
    sql.append("    and tranlevel.pk_org=co.pk_org ");
    sql.append("    and tranlevel.cperiod", cperiod);
    sql.append("    and tranlevel.dr=0");
    sql.append("    and co.pk_group", pk_group);
    sql.append("    and co.dr=0");
    sql.append(" and maincostobj.pk_org", pk_orgs);
    DataAccessUtils util = new DataAccessUtils();
    IRowSet result = util.query(sql.toString());
    if (result != null)
      while (result.next()) {
        String key = result.getString(0);
        Integer level = result.getInteger(1);
        if (level != null && (!lowerUAMap.containsKey(key) || ((Integer)lowerUAMap.get(key)).compareTo(level) > 0))
          lowerUAMap.put(key, level); 
      }  
    return lowerUAMap;
  }
}
